﻿/// <reference path="jquery-1.3.2.js" />
var GloabParams = new Object();
var g_MenuCreated = 0;
var g_UserType = 0;
var g_FirstTime = 0;
var g_SaveCall = 0;

function getColumnSrcIndexByName(columnName) {
    var cm = $("#QAList")[0].p.colNames,
        i = 0, index = 0, l = cm.length;
    while (i < l) {
        if (cm[i] == columnName) {
            return index;
        } else if (cm[i] !== 'rn' && cm[i] !== 'cb' && cm[i] !== 'subgrid') {
            index++;
        }
        i++;
    }
    return -1;
}

function successFunction(jsondata) {
    $("#blocker").show();
    var thegrid = jQuery("#QAList")[0];
    thegrid.addJSONData(JSON.parse(jsondata.d));
    $("#blocker").hide();
}

function ErrorFunction(result) { //alert(result.statusText);
    $("#blocker").show();
    alert("No Record Found");
    $("#blocker").hide();
}


function getSurveyList(pdata) {
    $("#blocker").show();
    var params = new Object();
    params.page = pdata.page;
    params.rows = pdata.rows;
    params.sidx = pdata.sidx;
    params.sord = pdata.sord;

    if (pdata.page == '1') {
        $.ajax({
            url: "PageFunctions.aspx/GetSurveyList",
            data: JSON.stringify(params),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function (postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: successFunction,
            error: ErrorFunction

        });
    }
    else {
        $.ajax({
            url: "PageFunctions.aspx/GetSurveyListNextPage",
            data: JSON.stringify(params),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function (postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: successFunction,
            error: ErrorFunction

        });
    }
}
function getImage(cell, options, row) {
    var rowdata = "";
    if (parseInt(cell) == 0) {
        rowdata = rowdata + '<img src="./Images/publish.png" style="cursor:pointer;" onclick="return PublishSurvey(' + row[0] + ');"/>&nbsp;&nbsp;&nbsp;<img src="./Images/editIcon.png" style="cursor:pointer;" onclick="return EditSurvey(' + row[0] + ');"/>&nbsp;&nbsp;&nbsp;<img src="./Images/delete.gif" style="cursor:pointer;" onclick="return DelSurvey(' + row[0] + ');"/>';
    }
    else if (parseInt(cell) == 1) {
        rowdata = rowdata + '<img src="./Images/disablepublish.png" style="cursor:pointer;" onclick="return EvaluateDoubleClickedCalls(' + row[0] + ');" title="View Evaluation Form"/>';
    }
    return (rowdata);
}

function PublishSurvey(SurveyRowID) {
    var RowData = jQuery("#QAList").getRowData(SurveyRowID);
    var QuestionIDX = RowData["QuestionIDX"];
    if (QuestionIDX == "0") {
        alert("Questions in the QA Form are 0. Please add questions before publishing.");
        return false;
    }
    var r = confirm("Are You sure to publish the selected QA Evaluation form?");
    if (r == false)
        return false;
    
    var params = new Object();
    params.surveyID = SurveyRowID;
    $.ajax({
        url: "PageFunctions.aspx/PublishQAEvaluationForm",
        data: JSON.stringify(params),  // For empty input data use "{}",
        dataType: "json",
        type: "POST",
        serializeGridData: function (postData) {
            return JSON.stringify(postData);
        },
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            if ($.isNumeric(result.d) && result.d > 0) {

                var chageImage = "<img src=\"Images/disablepublish.png\" style=\"cursor:pointer;\" onclick=\"return EvaluateDoubleClickedCalls(' + row[0] + ');\" title=\"View Evaluation Form\"/>";
                jQuery("#QAList").setCell(SurveyRowID, 8, chageImage, '', '');
                jQuery("#QAList").setCell(SurveyRowID, 7, 'Published', '', '');
            } else {
                alert("Unable to publish QA Evaluation form in database");
            }
        },
        error: function (result) { alert(result.statusText); }
    });
}

function EditSurvey(SurveyRowID) {
    window.location = "Campaign.aspx?SurveyID=" + SurveyRowID;
}

function DelSurvey(SurveyRowID) {
    var r = confirm("Are you sure to delete the selected QA Evaluation form?");
    if (r == false)
        return false;
    
    var params = new Object();
    params.surveyID = SurveyRowID;
    $.ajax({
        url: "PageFunctions.aspx/DeleteQAEvaluationForm",
        data: JSON.stringify(params),  // For empty input data use "{}",
        dataType: "json",
        type: "POST",
        serializeGridData: function (postData) {
            return JSON.stringify(postData);
        },
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            if ($.isNumeric(result.d) && result.d > 0) {
                jQuery('#QAList').delRowData(SurveyRowID);
            } else {
                alert("Unable to delete QA Evaluation form in database");
            }
        },
        error: function (result) { alert(result.statusText); }
    });
    
}

function dataBindToGrid() {
    jQuery("#QAList").jqGrid(
        {
            datatype: function (pdata) { getSurveyList(pdata); },
            colNames: ['QA Form ID', 'Campaign Name', 'Questions', 'Score', 'Start Date', 'End Date', 'Publish Status', 'Action'],
            colModel: [{ name: 'IDX', index: 'IDX', width: 40, align: 'center', key: true, hidden: true },
                { name: 'TitleIDX', index: 'TitleIDX', width: 300, align: 'left', hidden: false },
                { name: 'QuestionIDX', index: 'QuestionIDX', width: 100, align: 'left', hidden: false },
                { name: 'ScoreIDX', index: 'ScoreIDX', width: 100, align: 'left', hidden: false },
                { name: 'StartOnIDX', index: 'StartOnIDX', width: 85, align: 'center', hidden: false },
                { name: 'ExpireOnIDX', index: 'ExpireOnIDX', width: 85, align: 'center', hidden: false },
                { name: 'PublishIDX', index: 'PublishIDX', width: 120, align: 'center' },
                { name: 'ActionIDX', index: 'ActionIDX', width: 90, align: 'center', editable: true, formatter: getImage, hidden: false }
            ],
            loadonce: false,
            paging: true,
            rowNum: $('#ctl00_MainContent_txtRowCount').val(),
            viewrecords: true,
            mtype: "POST",
            sortable: true,
            pager: '#pager',
            reloadAfterSubmit: false,
            sortname: 'IDX',
            gridview: true,
            sortorder: "asc",
            height: $("#tdGrid").height() - 61,
            width: $("#tdGrid").width(),
            shrinkToFit: false,
            multiselect: false,
            rownumbers: true,
            altRows: true,
            altclass: 'myAltRowClass',
            ondblClickRow: function (rowid) {
                EvaluateDoubleClickedCalls(rowid);
            }
        });
}

function DBCLICKeVENT(id) {
    var ASPlayer = document.getElementById("ASPlayer");
    try {
        ASPlayer.ChangePlay(id);
        if (l_LoggedID != id) {
            l_LoggedID = id;
            SaveCallOperationLog(id, 1);
        }
    } catch(e) {
    }
}

function RefreshGrid() {
    jQuery("#QAList").setGridParam({ page: 1 });
    jQuery("#QAList").trigger("reloadGrid");
}


//utility function to get the container of an element by tagname 

function GetParentByTagName(parentTagName, childElementObj) {
    var parent = childElementObj.parentNode;
    while (parent.tagName.toLowerCase() != parentTagName.toLowerCase()) {
        parent = parent.parentNode;
    }
    return parent;
}

function EvaluateDoubleClickedCalls(rowid) {
    var row = $("#QAList").getRowData(rowid);
    $("#blocker").show();
    $("#EvaluationFormDiv").empty();
    $("#EvaluationFormDiv").html("");
    $("#EvaluationFormDiv").append('<div style="display: none;" id="EvalDivCount"></div>');
    var rowsCount = 0;
    rowsCount++;
    var header = '<div class="EvaluationHeader">' +
        '<div id="divQuestionContainer" class="" style="padding: 10px;">' +
        '<div id="divQuestions" class="Surveyheader">';
    
    var params = new Object();
    params.surveyID = row["IDX"];

    $.ajax({ type: "POST",
        async: false,
        url: "PageFunctions.aspx/GetSurveyQuestionsInfo",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify(params),  // For empty input data use "{}",
        serializeGridData: function (postData) {
            return JSON.stringify(postData);
        },
        dataType: "json",
        success: function (results) {
            try {
                var obj = $.parseJSON(results.d);
                $.each(obj, function () {
                    var questiontype = "checkbox";
                    if (this["QuestionType"] == 1) {
                        questiontype = "radio";
                    }
                    header = header + '<div>' +
                                '<div id="questionHeader" questype="' + questiontype + '" class="questionHeader" templatename="question" questionid="' + this["ID"] + '">'
                                + this["Question"] + '   <b style="color:blue;">Maximum Scores:[' + this["QuestionRate"] + ']</b>' +
                                '</div>';

                    var qid = this["ID"];
                    //Answer div start
                    header = header + '<div class="EvalationAnsCss" id="divAnswers_' + this["ID"] + '" templatename="answer" style="padding-right: 0 20px 10px; margin: 10px 10px;">';
                    params = new Object();
                    params.questionID = qid;

                    $.ajax({ type: "POST",
                        async: false,
                        url: "PageFunctions.aspx/GetOptionQuestionsInfo",
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify(params),  // For empty input data use "{}",
                        serializeGridData: function (postData) {
                            return JSON.stringify(postData);
                        },
                        dataType: "json",
                        success: function (results1) {
                            try {
                                var obj = $.parseJSON(results1.d);
                                $.each(obj, function () {
                                    var selected = "checked = \"checked\""; //checked = "checked"
                                    if (this["optiontrue"] == 0)
                                        selected = "";
                                    header = header + '<label><input type="' + questiontype + '"  value="' + this["ID"] + '_' + qid + '" defaultvalue="False" currentvalue="False" >' + this["OptionText"] + '   <b style="color:blue;">Scores: {' + this["OptionRate"] + '}</b></label><br>';
                                });
                                header = header + '</div>';
                            }
                            catch (e) {
                                alert("LoadSurvey JSON parsing Error.");
                            }
                        }
                    });

                });
            } catch (e) {
                alert("LoadSurvey JSON parsing Error.");
            }
        }
    });
    header = header + '</div>';
    header = header + '</div>';
    header = header + '</div>';
    $("#EvaluationFormDiv").append(header);
    $("#EvaluationFormDiv").dialog({
        maxWidth: 1000,
        maxHeight: $(window).height() - 40,
        width: 1000,
        height: $(window).height() - 40,
        buttons: {
             'Close': function () { $(this).dialog("close"); }
        },
         title: 'Call Evaluation Form: ' + row["TitleIDX"],
        modal: true,
        open: function () {
            $(this).parent().appendTo();
        }
    });
    $("#blocker").hide();
}

